@function gap($key: 3) {
  $map: $spacers;
  @if map-has-key($map, $key) {
    @return map-get($map, $key);
  } @else {
    $valid-keys: "";
    @each $valid-key, $_ in $map {
      @if ($valid-keys == "") {
        $valid-keys: $valid-key
      } @else {
        $valid-keys: "#{$valid-keys}, #{$valid-key}";
      }
    }
    $error-message: "The key #{$key} is not present in $spacers. Try one of the following: #{$valid-keys}";
    @error $error-message;
  }
}

// @note WIP: Experimental function for inner and outer spacings
$directions: (
  top,
  right,
  bottom,
  right
);

@function paddings($gaps, $pinpoint: false) {
  @return spacing($gaps: $gaps, $type: "padding", $pinpoint: $pinpoint);
}

@function margins($gaps, $pinpoint: false) {
  @return spacing($gaps: $gaps, $type: "margin", $pinpoint: $pinpoint);
}

@function spacing($gaps, $type, $pinpoint: false) {
  @if length($gaps) > 4 {
    @error "Too many values. Please pass not more than 4 values.";
  }

  @if not ($type == "padding") and not ($type == "margin") {
    @error "The code has not been tested with passed type '#{$type}'. Please use one of the following functions: paddings() or margins().";
  }

  $output: "";
  $values: ();

  @each $gap in $gaps {
    $values: append($values, gap($gap));
  }

  @if $pinpoint {
    $paddings: zip($directions, $values);
    @each $padding in $paddings {
      $output: $output + "#{$type}-#{nth($padding, 1)}: #{nth($padding, 2)}; ";
    }
  }
  @else {
    $output: "#{$type}: #{$values};";
  }

  @return $output;
}
